/* 
 * Copyright (c) 1988 Michael A. Cooper, University of Southern California.
 * This program may be used, copied, modified, and redistributed freely
 * for noncommercial purposes, so long as this notice remains intact.
 */

#ifndef lint
static char *RCSid = "$Header: c_delete.c,v 4.1 88/07/05 15:58:25 mcooper Exp $";
#endif

/*
 *------------------------------------------------------------------
 *
 * $Source: /usr/skat3/src/common/usc/etc/downtime/RCS/c_delete.c,v $
 * $Revision: 4.1 $
 * $Date: 88/07/05 15:58:25 $
 * $State: Exp $
 *
 *------------------------------------------------------------------
 *
 * Michael A. Cooper
 * Research and Development Group
 * University Computing Services 
 * University of Southern California
 * (mcooper@oberon.USC.EDU)
 *
 *------------------------------------------------------------------
 *
 * $Log:	c_delete.c,v $
 * Revision 4.1  88/07/05  15:58:25  mcooper
 * Added copyright notice.
 * 
 * Revision 4.0  88/04/20  15:41:21  mcooper
 * Version 4.
 * 
 * Revision 3.2  88/04/15  16:05:05  mcooper
 * Pass new flags to delete().
 * 
 * Revision 3.1  88/03/01  15:48:38  mcooper
 * Cleaned up header files.
 * 
 * Revision 3.0  87/07/24  14:13:11  mcooper
 * Version 3.
 * 
 *------------------------------------------------------------------
 */


#include "defs.h"
#include "parse.h"

fdb *mkdtfdb();

/*
 * c_delete - Ccmd interface to delete.
 */

c_delete()
{
  char *date;
  pval val;
  fdb *used;
  fdb *dfdb;
  int flgs;

  if ((dfdb = mkdtfdb()) == NULL)
    return(-1);

  noise("entry number");
  parse(dfdb, &val, &used);
  confirm();

  date = ttod(((struct downtime *)val._pvint)->dt_down);

  flgs = DOKILL | SENDCANCEL;
  if (force)
    flgs |= FORCE;
  if (quiet)
    flgs |= QUIET;

  return(delete(date, flgs));
}
