/* 
 * Copyright (c) 1988 Michael A. Cooper, University of Southern California.
 * This program may be used, copied, modified, and redistributed freely
 * for noncommercial purposes, so long as this notice remains intact.
 */

/*
 * $Header: defs.h,v 4.4 88/07/05 15:57:28 mcooper Exp $
 *------------------------------------------------------------------
 *
 * $Source: /usr/skat3/src/common/usc/etc/downtime/RCS/defs.h,v $
 * $Revision: 4.4 $
 * $Date: 88/07/05 15:57:28 $
 * $State: Exp $
 *
 *------------------------------------------------------------------
 *
 * Michael A. Cooper
 * Research and Development Group
 * University Computing Services 
 * University of Southern California
 * (mcooper@oberon.USC.EDU)
 *
 *------------------------------------------------------------------
 * $Log:	defs.h,v $
 * Revision 4.4  88/07/05  15:57:28  mcooper
 * - Added copyright notice.
 * - Moved configuration information to config.h.
 * 
 * Revision 4.3  88/05/24  12:57:49  mcooper
 * Force TRUE and FALSE to be locally defined.
 * 
 * Revision 4.2  88/05/23  16:22:54  mcooper
 * Declare xmalloc() and dtot().
 * 
 * Revision 4.1  88/04/20  16:54:06  mcooper
 * Defined PAGER for use with help.
 * 
 * Revision 4.0  88/04/20  15:43:25  mcooper
 * Version 4.
 * 
 * Revision 3.9  88/04/19  18:24:43  mcooper
 * - Move flag declarations to flags.h.
 * - The debug variable is now a value of "verbose".
 * 
 * Revision 3.8  88/04/13  19:15:05  mcooper
 * - All the option flags have been redone.
 * - General organization cleanup.
 * 
 * Revision 3.7  88/04/11  19:44:35  mcooper
 * The dt_flags member of struct downtime
 * is now an int.  All F_* defines are
 * now bits for dt_flags.
 * 
 * Revision 3.6  88/04/07  19:08:04  mcooper
 * Added another date (D_*) format.
 * 
 * Revision 3.5  88/03/15  14:41:47  mcooper
 * Malloc dt_shutter and dt_reason.
 * 
 * Revision 3.4  88/03/02  16:11:10  mcooper
 * Cleanup time.
 * 
 * Revision 3.3  88/03/01  15:47:54  mcooper
 * Cleaned up header files.
 * 
 * Revision 3.2  88/01/21  20:28:18  mcooper
 * Port to Alliant (Concentrix 3.0).
 * 
 * Revision 3.1  87/12/11  18:12:09  mcooper
 * Added D_MOTD for /etc/motd style date.
 * 
 * Revision 3.0  87/07/24  12:54:24  mcooper
 * Version 3.
 * 
 *------------------------------------------------------------------
 */

#ifndef __DEFS__
#define __DEFS__

#include <stdio.h>                              /* In case includer hasn't */
#include <ctype.h>
#include <sys/param.h>
#include <sys/time.h>
#include <sys/file.h>

#include "config.h"
#include "dttime.h"
#include "flags.h"

#if !defined(NO_CCMD)                           /* In case we don't want it */

/*
 * Include Ccmd's main header file ccmd.h.
 */
#include <ccmd.h>

#endif /* NO_CCMD */

/*
 * Centre of the universe
 */
struct downtime {
  struct tm   *dt_down;                  /* Time going down */
  struct tm   *dt_up;                    /* Time coming up */
  struct tm   *dt_orderdown;             /* Time downtime was entered */
  char        *dt_reason;                /* Reason for the downtime */
  char        *dt_shutter;               /* Person ordering the downtime */
  char         dt_host[MAXHOSTNAMELEN];  /* Host on which shutter resides */
  int          dt_flags;                 /* Flag field */
  int          dt_islocked;              /* Is this entry locked? */
};


#ifdef RPCWALL
struct hostlist {
    char *host;
    struct hostlist *nxt;
} *hostlist;
#endif RPCWALL

extern int killflg, fake, halt, reboot, fastboot, nosync;
extern int motdtime, warntime, uflag, nowflg, force, quiet;
extern int shortshutmsg, verbose, iflag, uflag;

extern char host[], datafile[], helpfile[];
extern char *version, *prog, *username, *nologin;

char *newstr(), *ttod(), *index(), *rindex(), *mkdate(), *timeleft();
char *xmalloc();
struct downtime *getdtent(), *getdtdate();
struct tm *getdate(), *getplus(), *dtot();
FILE *fopen();

typedef int (*procptr)();


#endif /* __DEFS__ */
