/* 
 * Copyright (c) 1988 Michael A. Cooper, University of Southern California.
 * This program may be used, copied, modified, and redistributed freely
 * for noncommercial purposes, so long as this notice remains intact.
 */

/*
 * $Header: flags.h,v 4.1 88/07/05 15:59:43 mcooper Exp $
 *------------------------------------------------------------------
 *
 * $Source: /usr/skat3/src/common/usc/etc/downtime/RCS/flags.h,v $
 * $Revision: 4.1 $
 * $Date: 88/07/05 15:59:43 $
 * $State: Exp $
 *
 *------------------------------------------------------------------
 *
 * Michael A. Cooper
 * Research and Development Group
 * University Computing Services 
 * University of Southern California
 * (mcooper@oberon.USC.EDU)
 *
 *------------------------------------------------------------------
 * $Log:	flags.h,v $
 * Revision 4.1  88/07/05  15:59:43  mcooper
 * Added copyright notice.
 * 
 * Revision 4.0  88/04/20  15:43:39  mcooper
 * Version 4.
 * 
 * Revision 3.1  88/04/20  13:37:54  mcooper
 * Replace F_BROADCAST with F_MSG_REMOTE.
 * Added F_MSG_LOCAL.
 * 
 * Revision 3.0  88/04/19  18:24:29  mcooper
 * Version 3.
 * 
 *------------------------------------------------------------------
 */


/*
 * Option flags (for dt_flags)
 */
                                             /* How to bring down the system */
#define F_KILL                  0x00001      /*      - Regular Kill          */
#define F_HALT                  0x00002      /*      - Halt                  */
#define F_REBOOT                0x00004      /*      - Reboot                */
#define F_FAKE                  0x00008      /*      - Fake the shutdown     */
#define F_MOTD                  0x00010      /* Message in /etc/motd?        */
#define F_DONEMOTD              0x00020      /* motd has been added          */
#define F_MSG_REMOTE            0x00040      /* Send remote (RPC) messages   */
#define F_MSG_LOCAL             0x00080      /* Send local warning messages  */
                                             /* Fastboot OR NoSync           */
#define F_FASTBOOT              0x00100      /*      - Fastboot              */
#define F_NOSYNC                0x00200      /*      - No Sync               */
                                             /* Type of shutdown message     */
#define F_SHUTMSG_ONE           0x00400      /*      - One line format       */
#define F_SHUTMSG_VER           0x00800      /*      - Verbose format        */

/*
 * General flags
 */

#define DOKILL                  0x00001      /* Kill active downtimes        */
#define SENDCANCEL              0x00002      /* Send cancel message          */
#define FORCE                   0x00004      /* Force                        */
#define QUIET                   0x00008      /* Be quiet                     */
#define ISNOW                   0x00010      /* Do it now                    */
